import React from 'react';
import ReactDOM from 'react-dom';
import {csv,nest} from 'd3';
import PACK from './pack'

class App extends React.Component { 
  
  constructor(props){
    super(props) 
    this.state = {data:null}
  }
  
  componentDidMount(){
    this.getCSV('celeb.csv')
  }
  
  
  async getCSV(name){
     let data = await csv('celeb.csv')
     
     
    const process = (table) => {
      
      table.map(d => d.sample = +d.sample)
      
      const seperated =nest().key(d=> d.category).key(d=>d.gender).entries(table)
   
      
      const rename = (node)=> {

                              node.forEach(n => {
                                 if(n.key){
                                     Object.keys(n).forEach(k => {
                                      if(k=='key'){
                                         n['name'] = n[k]
                                         delete n[k]
                                      }else{
                                         n['children'] = n[k]
                                         delete n[k]
                                      }
                                   }) 
                                 }  
                                 if(n.children)rename(n.children)
                              })
                            return node;
                          }
                    let renamed = rename(seperated)
                    let data = {}
                    data['name'] = 'celebrities'
                    data['children'] = renamed
                    this.setState({data:data})
          }
      process(data)
  }
  
  render(){
    return [
            <h1>{this.props.title}</h1>,
            this.state.data? <PACK data ={this.state.data}/>: <h9> Loading SVG</h9>];
  }

};

ReactDOM.render(<App title="Celebrity Sample visualization" />, document.getElementById('root'));
